property mySprite, getPDLError, myClickMode, myEventPassMode

on getBehaviorDescription me
  return "SET CLICK MODES" & RETURN & RETURN & "Determine how a Flash sprite reacts to mouse clicks and whether the mouse events are subsequently passed to Director." & RETURN & RETURN & "Default values are those of the member of the current sprite." & RETURN & RETURN & "PERMITTED MEMBER TYPES:" & RETURN & "Flash members" & RETURN & RETURN & "PARAMETERS:" & RETURN & "* clickMode (boundingBox | opaque | object)" & RETURN & "* eventPassMode (passAlways | passButton | passNotButton | passNever)"
end

on getBehaviorTooltip me
  return "Use with Flash sprites. " & "Use the Parameters dialog to determine how a Flash sprite reacts to mouse clicks and whether the mouse events are subsequently passed to Director."
end

on beginSprite me
  Initialize(me)
end

on Initialize me
  mySprite = sprite(me.spriteNum)
  mySprite.clickMode = myClickMode
  mySprite.eventPassMode = myEventPassMode
end

on isOKToAttach me, aSpriteType, aSpriteNum
  case aSpriteType of
    #graphic:
      return getPos([#flash], sprite(aSpriteNum).member.type) <> 0
    #script:
      return 0
  end case
end

on getPropertyDescriptionList me
  if not (the currentSpriteNum) then
    exit
  end if
  theMember = sprite(the currentSpriteNum).member
  return [#myClickMode: [#comment: "Click Mode", #format: #symbol, #range: [#boundingBox, #opaque, #object], #default: theMember.clickMode], #myEventPassMode: [#comment: "Event Pass Mode", #format: #symbol, #range: [#passAlways, #passButton, #passNotButton, #passNever], #default: theMember.eventPassMode]]
end
